using System.Web.Mvc;
using Toast.Attributes;
using Toast.Core;

namespace Toast.DemoSite.Controllers
{
    [HandleError]
    public class HomeController : BaseController
    {
        [Content(InjectAt.HeadBottom, "/Scripts/Views.Home.js")]
        public ActionResult Index()
        {
            ViewData["Message"] = "Welcome to ASP.NET MVC!";

            return View();
        }

        [Content(InjectAt.HeadBottom, "/Scripts/Views.About.js")]
        public ActionResult About()
        {
            return View();
        }

        [Content(InjectAt.Inline, "alert('Hi!');")]
        public PartialViewResult Partial()
        {
            return PartialView("APartialView");
        }
    }
}